/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10
	test for picture handling

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 21 December 1995
*/

#include "mem_h"
#include "job_h"
#include "io_h"

#include "PROforma_h"

#define catch(x) if (err=(x)) return err; else

Bbox bbox = { short2pt(595), short2pt(300), short2pt(0), short2pt(0) };

Error init()
{
	Gstate gstate;
	Error err;
	char *base;
	Channel file,chid;
	char str[80],time[30];
	Time before,after;
	Size size;
	pt list[8]={0,0,0,0,short2pt(100),short2pt(100),short2pt(100),short2pt(100)};

	err=IOOpen("ram1_pictime_txt",OPEN_OLD,&chid);
	if (err) err=IOOpen("ram1_pictime_txt",OPEN_OVER,&chid);
	if (err) return err;
	IOPositionSet(chid,TO_END_OF_FILE);


	LinkPROforma();
	catch( PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL) );
/*	  catch( PFGstateInit(PF_NAME("Epson Stylus Colour 180dpi"),"pard",&bbox,&gstate,NULL) ); */
	
	catch( IOOpen("win2_tmp_car2_com",OPEN_OLD,&file) );
	catch( IOLength(file,&size) );
	catch( MEMAllocate(size+sizeof(FileInfo),&base) );
	catch( IOFileInfoGet(file,(FileInfo *)base) );
	catch( IOFileLoad(file,size,base+sizeof(FileInfo)) );
	IOClose(file);

	PFMoveTo(gstate,short2pt(50),short2pt(50));
	TIMEGet(&before);
	PFPictureDisplay(gstate,PF_PICTURE_PAINTER8,base, short2pt(495), short2pt(200));
/*	  PFPictureDisplayGray(gstate,PF_PICTURE_PAINTER8,base, short2pt(495), short2pt(200), list); */
	TIMEGet(&after);
	err=PFPageShow(gstate);

	STRTime(before,time);
	STRFormatPut(str,"before %s",time);
	IOPutString(chid,str,NULL);
	STRTime(after,time);
	STRFormatPut(str,"after %s",time);
	IOPutString(chid,str,NULL);
	STRFormatPut(str,"time used %d seconds",after-before);
	IOPutString(chid,str,NULL);
	PFFontScale(gstate,short2pt(20));
	PFStringShow(gstate,"The picture is displayed here ");
	IOClose(chid);

return err;
	{
		Time start, curr;

		/* wait for approx 15sec. */
		TIMEGet(&start);
		do {
			JOBSuspend(MYSELF,1,NULL);
			TIMEGet(&curr);
		} while (start+15>curr);
	}
	return err;
}
